/*

*/

import static java.util.concurrent.TimeUnit.MILLISECONDS;

/**
   Continually remove an item from the buffer
   and then sleep for a small amount of time.
*/
public class Consumer implements Runnable
{
   private final Buffer buf;
   private final int milliSeconds;

   public Consumer(Buffer buf, int milliSeconds)
   {
      this.buf = buf;
      this.milliSeconds = milliSeconds;
   }

   @Override
   public void run()
   {
      try
      {
         while(! Thread.currentThread().isInterrupted())
         {
            buf.get();
            MILLISECONDS.sleep(milliSeconds);
         }
      }
      catch (InterruptedException e)
      {
         // Print a stack trace and then the thread dies.
         e.printStackTrace();
      }
   }
}
