/*

*/

import static java.util.concurrent.TimeUnit.SECONDS;

/**
   Create a buffer, and then create and start a number
   of producer and consumer threads that use the buffer.
*/
public class ProducerConsumer
{
   public static void main(String[] args) throws InterruptedException
   {
      final Buffer buf = new Buffer_monitor_bounded(80, 40); // half full
      final Runnable producer = new Producer(buf, 40);
      final Runnable consumer = new Consumer(buf, 50);
      final Thread t1 = new Thread(producer);
      final Thread t2 = new Thread(consumer);
      t1.start();
      t2.start();

      SECONDS.sleep(10);  // 10 seconds
    //SECONDS.sleep(300); // 5 minutes

      t1.interrupt();
      t2.interrupt();

      t1.join(); System.out.println("t1 done");
      t2.join(); System.out.println("t2 done");

      System.out.println("All threads done.");
   }
}
